--- lrb_prototype_primitives.inl	2010-06-15 17:01:51.147217886 +0200
+++ lrbni_prototypes.h	2010-06-15 17:01:22.767217213 +0200
@@ -11017,9 +11041,9 @@
 inline _M512D _mm512_mask_log10_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11036,8 +11060,8 @@
 inline _M512 _mm512_log10_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = log10f(p1[i]);
@@ -11049,9 +11073,9 @@
 inline _M512 _mm512_mask_log10_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11068,8 +11092,8 @@
 inline _M512D _mm512_log2_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = log(p1[i]) * 1.4426950408889634073599246810019;  // 1 / Ln(2)
@@ -11081,9 +11105,9 @@
 inline _M512D _mm512_mask_log2_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11100,8 +11124,8 @@
 inline _M512 _mm512_log2_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = logf(p1[i]) * 1.4426950408889634073599246810019f;     // 1 / Ln(2)
@@ -11113,9 +11137,9 @@
 inline _M512 _mm512_mask_log2_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11132,8 +11156,8 @@
 inline _M512D _mm512_log_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = log(p1[i]);
@@ -11145,9 +11169,9 @@
 inline _M512D _mm512_mask_log_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11164,8 +11188,8 @@
 inline _M512 _mm512_log_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = logf(p1[i]);
@@ -11177,9 +11201,9 @@
 inline _M512 _mm512_mask_log_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11196,9 +11220,9 @@
 inline _M512D _mm512_pow_pd(_M512D v1, _M512D v2)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = pow(p1[i], p2[i]);
@@ -11210,10 +11234,10 @@
 inline _M512D _mm512_mask_pow_pd(_M512D v0_old, __mmask k1, _M512D v1, _M512D v2)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11230,9 +11254,9 @@
 inline _M512 _mm512_pow_ps(_M512 v1, _M512 v2)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = powf(p1[i], p2[i]);
@@ -11244,10 +11268,10 @@
 inline _M512 _mm512_mask_pow_ps(_M512 v0_old, __mmask k1, _M512 v1, _M512 v2)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11264,8 +11288,8 @@
 inline _M512D _mm512_sin_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = sin(p1[i]);
@@ -11277,9 +11301,9 @@
 inline _M512D _mm512_mask_sin_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11296,8 +11320,8 @@
 inline _M512 _mm512_sin_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = sinf(p1[i]);
@@ -11309,9 +11333,9 @@
 inline _M512 _mm512_mask_sin_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11328,8 +11352,8 @@
 inline _M512D _mm512_sinh_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = sinh(p1[i]);
@@ -11341,9 +11365,9 @@
 inline _M512D _mm512_mask_sinh_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11360,8 +11384,8 @@
 inline _M512 _mm512_sinh_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = sinhf(p1[i]);
@@ -11373,9 +11397,9 @@
 inline _M512 _mm512_mask_sinh_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11392,8 +11416,8 @@
 inline _M512D _mm512_sqrt_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = sqrt(p1[i]);
@@ -11405,9 +11429,9 @@
 inline _M512D _mm512_mask_sqrt_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11424,8 +11448,8 @@
 inline _M512 _mm512_sqrt_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = sqrtf(p1[i]);
@@ -11437,9 +11461,9 @@
 inline _M512 _mm512_mask_sqrt_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11456,8 +11480,8 @@
 inline _M512D _mm512_tan_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = tan(p1[i]);
@@ -11469,9 +11493,9 @@
 inline _M512D _mm512_mask_tan_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11488,8 +11512,8 @@
 inline _M512 _mm512_tan_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = tanf(p1[i]);
@@ -11501,9 +11525,9 @@
 inline _M512 _mm512_mask_tan_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11520,8 +11544,8 @@
 inline _M512D _mm512_tanh_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = tanh(p1[i]);
@@ -11533,9 +11557,9 @@
 inline _M512D _mm512_mask_tanh_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -11552,8 +11576,8 @@
 inline _M512 _mm512_tanh_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = tanhf(p1[i]);
@@ -11565,9 +11589,9 @@
 inline _M512 _mm512_mask_tanh_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11586,7 +11610,7 @@
     float result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p2 = (float *) &v2;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -11595,7 +11619,7 @@
 #else
     __m128 *p2 = (__m128 *) &v2;
     __m128 tmp;
-    float *r = (float *) &tmp;
+    _LPP_Float *r = (_LPP_Float *) &tmp;
     
     tmp = _mm_add_ps(_mm_add_ps(p2[0], p2[1]), _mm_add_ps(p2[2], p2[3]));    
     result = r[0] + r[1] + r[2] + r[3];
@@ -11608,7 +11632,7 @@
 inline float _mm512_mask_reduce_add_ps(__mmask k1, _M512 v2)
 {
     float result = 0;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result += p2[i];
@@ -11623,7 +11647,7 @@
     double result;
     
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p2 = (double *) &v2;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     result = p2[0];
     for (int i=1; i < 8; i++) {
@@ -11632,7 +11656,7 @@
 #else
     __m128d *p2 = (__m128d *) &v2;
     __m128d tmp;
-    double *r = (double *) &tmp;
+    _LPP_Double *r = (_LPP_Double *) &tmp;
     
     tmp = _mm_add_pd(_mm_add_pd(p2[0], p2[1]), _mm_add_pd(p2[2], p2[3]));    
     result = r[0] + r[1];
@@ -11645,7 +11669,7 @@
 inline double _mm512_mask_reduce_add_pd(__mmask k1, _M512D v2)
 {
     double result = 0;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) result += p2[i];
@@ -11660,7 +11684,7 @@
     int result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
     
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -11669,7 +11693,7 @@
 #else
     __m128i *p2 = (__m128i *) &v2;
     __m128i tmp;
-    int *r = (int *) &tmp;
+    _LPP_Int *r = (_LPP_Int *) &tmp;
     
     tmp = _mm_add_epi32(_mm_add_epi32(p2[0], p2[1]), _mm_add_epi32(p2[2], p2[3]));    
     result = r[0] + r[1] + r[2] + r[3];
@@ -11682,7 +11706,7 @@
 inline int _mm512_mask_reduce_add_pi(__mmask k1, _M512I v2)
 {
     int result = 0;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
     
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result += p2[i];
@@ -11697,7 +11721,7 @@
     float result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p2 = (float *) &v2;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -11706,7 +11730,7 @@
 #else
     __m128 *p2 = (__m128 *) &v2;
     __m128 tmp;
-    float *r = (float *) &tmp;
+    _LPP_Float *r = (_LPP_Float *) &tmp;
     
     tmp = _mm_mul_ps(_mm_mul_ps(p2[0], p2[1]), _mm_mul_ps(p2[2], p2[3]));    
     result = r[0] * r[1] * r[2] * r[3];
@@ -11719,7 +11743,7 @@
 inline float _mm512_mask_reduce_mul_ps(__mmask k1,_M512 v2)
 {
     float result = 1.0f;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result *= p2[i];
@@ -11734,7 +11758,7 @@
     double result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p2 = (double *) &v2;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     result = p2[0];
     for (int i=1; i < 8; i++) {
@@ -11743,7 +11767,7 @@
 #else
     __m128d *p2 = (__m128d *) &v2;
     __m128d tmp;
-    double *r = (double *) &tmp;
+    _LPP_Double *r = (_LPP_Double *) &tmp;
     
     tmp = _mm_mul_pd(_mm_mul_pd(p2[0], p2[1]), _mm_mul_pd(p2[2], p2[3]));    
     result = r[0] * r[1];
@@ -11756,7 +11780,7 @@
 inline double _mm512_mask_reduce_mul_pd(__mmask k1, _M512D v2)
 {
     double result = 1.0;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) result *= p2[i];
@@ -11769,7 +11793,7 @@
 inline int _mm512_reduce_mul_pi(_M512I v2)
 {
     int result;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -11783,7 +11807,7 @@
 inline int _mm512_mask_reduce_mul_pi(__mmask k1, _M512I v2)
 {
     int result = 1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result *= p2[i];
@@ -11798,7 +11822,7 @@
     float result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p2 = (float *) &v2;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
     
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -11807,7 +11831,7 @@
 #else
     __m128 *p2 = (__m128 *) &v2;
     __m128 tmp;
-    float *r = (float *) &tmp;
+    _LPP_Float *r = (_LPP_Float *) &tmp;
     
     tmp = _mm_min_ps(_mm_min_ps(p2[0], p2[1]), _mm_min_ps(p2[2], p2[3]));    
     result = _LPP_min(_LPP_min(r[0], r[1]), _LPP_min(r[2], r[3]));
@@ -11820,7 +11844,7 @@
 inline float _mm512_mask_reduce_min_ps(__mmask k1, _M512 v2)
 {
     float result = FLT_MAX;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
     
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result = _LPP_min(result, p2[i]);
@@ -11835,7 +11859,7 @@
     double result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p2 = (double *) &v2;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     result = p2[0];
     for (int i=1; i < 8; i++) {
@@ -11844,7 +11868,7 @@
 #else
     __m128d *p2 = (__m128d *) &v2;
     __m128d tmp;
-    double *r = (double *) &tmp;
+    _LPP_Double *r = (_LPP_Double *) &tmp;
     
     tmp = _mm_min_pd(_mm_min_pd(p2[0], p2[1]), _mm_min_pd(p2[2], p2[3]));    
     result = _LPP_min(r[0], r[1]);
@@ -11857,7 +11881,7 @@
 inline double _mm512_mask_reduce_min_pd(__mmask k1, _M512D v2)
 {
     double result = DBL_MAX;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) result = _LPP_min(result, p2[i]);
@@ -11870,7 +11894,7 @@
 inline int _mm512_reduce_min_pi(_M512I v2)
 {
     int result;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -11884,7 +11908,7 @@
 inline int _mm512_mask_reduce_min_pi(__mmask k1, _M512I v2)
 {
     int result = 0x7fffffff;    // MAX_INT
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=1; i < 16; i++) {
         if (k1 & 1) result = _LPP_min(result, p2[i]);
@@ -11899,7 +11923,7 @@
     float result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p2 = (float *) &v2;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -11908,7 +11932,7 @@
 #else
     __m128 *p2 = (__m128 *) &v2;
     __m128 tmp;
-    float *r = (float *) &tmp;
+    _LPP_Float *r = (_LPP_Float *) &tmp;
     
     tmp = _mm_max_ps(_mm_max_ps(p2[0], p2[1]), _mm_max_ps(p2[2], p2[3]));    
     result = _LPP_max(_LPP_max(r[0], r[1]), _LPP_max(r[2], r[3]));
@@ -11921,7 +11945,7 @@
 inline float _mm512_mask_reduce_max_ps(__mmask k1, _M512 v2)
 {
     float result = FLT_MIN;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result = _LPP_max(result, p2[i]);
@@ -11936,7 +11960,7 @@
     double result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p2 = (double *) &v2;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     result = p2[0];
     for (int i=1; i < 8; i++) {
@@ -11945,7 +11969,7 @@
 #else
     __m128d *p2 = (__m128d *) &v2;
     __m128d tmp;
-    double *r = (double *) &tmp;
+    _LPP_Double *r = (_LPP_Double *) &tmp;
     
     tmp = _mm_max_pd(_mm_max_pd(p2[0], p2[1]), _mm_max_pd(p2[2], p2[3]));    
     result = _LPP_max(r[0], r[1]);
@@ -11958,7 +11982,7 @@
 inline double _mm512_mask_reduce_max_pd(__mmask k1, _M512D v2)
 {
     double result = DBL_MIN;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) result = _LPP_max(result, p2[i]);
@@ -11971,7 +11995,7 @@
 inline int _mm512_reduce_max_pi(_M512I v2)
 {
     int result;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -11985,7 +12009,7 @@
 inline int _mm512_mask_reduce_max_pi(__mmask k1, _M512I v2)
 {
     int result = 0x80000000;        // MIN_INT
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result = _LPP_max(result, p2[i]);
@@ -12000,7 +12024,7 @@
     int result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -12009,7 +12033,7 @@
 #else
     __m128i *p2 = (__m128i *) &v2;
     __m128i tmp;
-    int *r = (int *) &tmp;
+    _LPP_Int *r = (_LPP_Int *) &tmp;
     
     tmp = _mm_or_si128(_mm_or_si128(p2[0], p2[1]), _mm_or_si128(p2[2], p2[3]));    
     result = r[0] | r[1] | r[2] | r[3];
@@ -12022,7 +12046,7 @@
 inline int _mm512_mask_reduce_or_pi(__mmask k1, _M512I v2)
 {
     int result = 0;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result |= p2[i];
@@ -12037,7 +12061,7 @@
     int result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     result = p2[0];
     for (int i=1; i < 16; i++) {
@@ -12046,7 +12070,7 @@
 #else
     __m128i *p2 = (__m128i *) &v2;
     __m128i tmp;
-    int *r = (int *) &tmp;
+    _LPP_Int *r = (_LPP_Int *) &tmp;
     
     tmp = _mm_and_si128(_mm_and_si128(p2[0], p2[1]), _mm_and_si128(p2[2], p2[3]));    
     result = r[0] & r[1] & r[2] & r[3];
@@ -12059,7 +12083,7 @@
 inline int _mm512_mask_reduce_and_pi(__mmask k1, _M512I v2)
 {
     int result = 0xffffffff;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) result &= p2[i];
